<?php
if(!defined("IN_MYBB"))
{
    die("You Cannot Access This File Directly. Please Make Sure IN_MYBB Is Defined.");
}

$plugins->add_hook('wobsystem_end', 'punkte_einteilung');
$plugins->add_hook('newreply_do_newreply_end', 'punkte_post');
$plugins->add_hook('global_start', 'showpoints');

function hauspunkte_info()
{
	global $lang;
	$lang->load('hauspunkte');
	return array
	(
        "name"  => $lang->points_name,
        "description"=> $lang->points_desc,
        "website"        => "http://asthelon.de",
        "author"        => "Celine Geneau",
        "authorsite"    => "http://asthelon.de",
        "version"        => "1.0",
        "guid"             => "",
        "compatibility" => "18*"
    );
} 

function hauspunkte_activate()
{
	global $db, $cache, $lang;
	
	$lang->load('hauspunkte');
	
	$plugins_cache = $cache->read("plugins");
	if (!isset($plugins_cache['active']['hp_listen']))
	{
		global $page, $lang;
		$page->output_confirm_action('index.php?module=config-plugins&action=deactivate&uninstall=1&plugin=hello', $lang->HP_list_activate_message, $lang->HP_list_activate);
	}
	else if (!isset($plugins_cache['active']['inplaytracker']))
	{
		global $page, $lang;
		$page->output_confirm_action('index.php?module=config-plugins&action=deactivate&uninstall=1&plugin=hello', $lang->inplaytracker_activate_message, $lang->inplaytracker_activate);
	}
	else
	{
		$setting_group = array(
		'name' => $lang->points_lowername,
		'title' => $lang->points_name,
		'description' => $lang->points_lowername_desc,
		'disporder' => 1,
		'isdefault' => 0
		);
		$gid = $db->insert_query("settinggroups", $setting_group);
		
		$setting_array = array(
			// A yes/no boolean box
			'points_per_post' => array(
					'title' => $lang->points_per_post,
					'description' => $lang->points_per_post_desc,
					'optionscode' => 'numeric
min=0',
					'value' => 0,
					'disporder' => 1
			),
			'points_per_wob' => array(
				'title' => $lang->points_per_wob,
				'description' => $lang->points_per_wob_desc,
				'optionscode' => 'numeric
min=0',
				'value' => 0,
			'disporder' => 2
			),
		);
	
		foreach($setting_array as $name => $setting)
		{
			$setting['name'] = $name;
			$setting['gid'] = $gid;
	
			$db->insert_query('settings', $setting);
		}
		rebuild_settings();
	}
	
	/*HAuspunkte-Template einfügen*/
	$template[0] = '<html>
<head>
<title>{$mybb->settings[\'bbname\']} - {$lang->hauspunkte_name}</title>
{$headerinclude}
<script type="text/javascript" src="{$mybb->asset_url}/jscripts/post.js?ver=1813"></script>
</head>
<body>
{$header}
{$point_errors}
<form action="hauspunkte.php?uid={$uid}&amp;processed=1" method="post" enctype="multipart/form-data" name="input">
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="2"><strong>{$lang->hauspunkte_name}</strong></td>
</tr>
<tr>
<td class="trow1" valign="top"><strong>{$lang->username}</strong><br /></td>
<td class="trow1">
<input type="text" id="username" name="username" value="{$username}" readonly>
</td>
<tr>
<tr>
<td class="trow2" valign="top"><strong>{$lang->reason}</strong><br /></td>
<td class="trow2">
<textarea id="reason" name="reason" rows="20" cols="70" tabindex="2" >{$reason}</textarea>
</td>
</tr>
<tr>
<td class="trow1" valign="top"><strong>{$lang->choice}</strong><br /></td>
<td class="trow1">
<select id="choice" name="choice">
	 <option value="plus" {$select[\'plus\']}>{$lang->plus}</option>
	 <option value="minus" {$select[\'minus\']}>{$lang->minus}</option>
</select>
</td>
</tr>
<tr>
<td class="trow2" valign="top"><strong>{$lang->points}</strong><br /></td>
<td class="trow2">
<input type="int" id="points" name="points" value="{$points}">
</td>
</tr>
</table>
<br />
<div align="center"><input type="submit" class="button" name="submit" value="{$lang->send}" tabindex="3" accesskey="s" /></div>
<input type="hidden" name="action" value="do_addpoints" />
<input type="hidden" name="uid" value="{$uid}" />
</form>
{$forumrules}
{$footer}
</body>
</html>';

	$templatelname[0]='hauspunkte';
	
	$i=0;
	$max=count($template);
	while($i<$max)
	{
		$insert_array = array(
			'title' => $templatelname[$i],
			'template' => $db->escape_string($template[$i]),
			'sid' => '-1',
			'version' => '',
			'dateline' => time()
		);
		
		$db->insert_query('templates', $insert_array);
		$i++;
	}
	
	/*neue PHP-Dateien erzeugen*/
	$phpname[0]='../hauspunkte.php';
	$phpinhalt[0]='<?php
   define("IN_MYBB", 1);
        require_once "./global.php";
        require_once MYBB_ROOT."inc/class_parser.php";

$lang->load(\'hauspunkte\');
$name=$lang->hauspunkte_name;

    add_breadcrumb($name, "hauspunkte.php");

if(is_moderator(1))
{
	if($mybb->input[\'action\'] == "do_addpoints" && $mybb->request_method == "post")
	{
		
		$username = $mybb->get_input(\'username\');
		$uid = $mybb->get_input(\'uid\');
		$choice = $mybb->get_input(\'choice\');
		$points = $mybb->get_input(\'points\');
		$reason = $mybb->get_input(\'reason\');
		
		$fromid=$mybb->user[\'uid\'];
		$toid=$uid;
		
		$query = $db->simple_select("users", \'points\', "uid=\'{$uid}\'");
		$userinfo = $db->fetch_array($query);
		
		if($choice=="minus")
		{
			if($userinfo[\'points\'] < $points) $points=$userinfo[\'points\'];
			if($userinfo[\'points\']==0)
			{
				$errors[$lang->hauspunkte_no_points]=$lang->hauspunkte_no_points;
			}
		}
		if(!$username)
		{
			$errors[$lang->hauspunkte_no_usname]=$lang->hauspunkte_no_usname;
		}
		if(!$reason)
		{
			$errors[$lang->hauspunkte_no_reason]=$lang->hauspunkte_no_reason;
		}
		
		if(count($errors) > 0)
		{
			$point_errors = inline_error($errors);
		}
		
		if($point_errors == \'\' || !$point_errors)
		{
			$query = $db->simple_select("userfields", \'fid13\', "ufid=\'{$uid}\'");
			$fidinfo = $db->fetch_array($query);
			
			if($fidinfo[\'fid13\'])
			{
				$update_user = array(
				"points" => $points
				);
				$db->update_query("users", $update_user, "uid=\'".$uid."\'");
				
				if($choice=="plus") $choice="+";
				else $choice="-";
				
				hauspunkte_pn($fromid,$toid,$choice,$points,$reason);
			}
			else
			{
				$errors[$lang->hauspunkte_no_student]=$lang->hauspunkte_no_student;
				$point_errors = inline_error($errors);
			}
		}
	}
	
	$select[$choice]=" selected";
	
	$uid = $mybb->get_input(\'uid\');
	
	$query = $db->simple_select("users", \'username\', "uid=\'{$uid}\'");
	$userinfo = $db->fetch_array($query);
	$username=$userinfo[\'username\'];
	
	eval("\$hauspunkte = \"".$templates->get("hauspunkte")."\";");
	output_page($hauspunkte);
}
else error_no_permission();

?>';

	$phpname[1]='../inc/languages/deutsch_sie/hauspunkte.lang.php';
	$phpinhalt[1]='<?php
/**
 * German language pack for MyBB 1.8
 * Deutsches Sprachpaket für MyBB 1.8
 * (c) 2005-2014 MyBBoard.de
 * 
 * Author/Autor: http://www.mybboard.de/
 * License/Lizenz: GNU Lesser General Public License, Version 3
 */
 
 $l[\'hauspunkte_name\'] = "Haupsunkte hinzufügen/abziehen";
 
 $l[\'username\'] = "Schülername";
 $l[\'reason\'] = "Grund für die Punkte";
 $l[\'choice\'] = "Sollen Punkte gegeben oder abgezogen werden?";
 $l[\'points\'] = "Wie viele Punkte sollen gegen/abgezogen werden?";
 $l[\'plus\'] = "Punkte geben";
 $l[\'minus\'] = "Punkte abziehen";
 $l[\'send\'] = "Abschicken";
 
 $l[\'hauspunkte_no_usname\'] = "Der Username muss ausgefüllt sein!";
 $l[\'hauspunkte_no_reason\'] = "Es muss ein Grund angegeben werden!";
 $l[\'hauspunkte_no_points\'] = "Dieser Charakter hat keine Punkte, die abgezogen werden können!";
 $l[\'hauspunkte_no_student\'] = "Dieser Charakter kann keine Punkte erhalten oder verlieren!";
 
 $l[\'points_reason\'] ="Einteilung in das Haus";
 $l[\'pm_subject\'] ="Punkteverteilung";
 $l[\'hauspunkte_pn\'] = "Sehr geehrter {username},
 
 Ihnen wurden Punkte zugeteilt oder abgezogen, dies geschah mit folgenden Informationen:
 
 Von wem: {adminname}
 Grund: {reason}
 Punkte: {choice}{points}
 
 Mit freundlichen Grüßen
 Das Forensystem";';

	$phpname[2]='../inc/languages/deutsch_du/hauspunkte.lang.php';
	$phpinhalt[2]='<?php
/**
 * German language pack for MyBB 1.8 (informal)
 * Deutsches Sprachpaket für MyBB 1.8 "informell" (Du)
 * (c) 2005-2014 MyBBoard.de
 * 
 * Author/Autor: http://www.mybboard.de/
 * License/Lizenz: GNU Lesser General Public License, Version 3
 */
 
 $l[\'hauspunkte_name\'] = "Haupsunkte hinzufügen/abziehen";
 
 $l[\'username\'] = "Schülername";
 $l[\'reason\'] = "Grund für die Punkte";
 $l[\'choice\'] = "Sollen Punkte gegeben oder abgezogen werden?";
 $l[\'points\'] = "Wie viele Punkte sollen gegen/abgezogen werden?";
 $l[\'plus\'] = "Punkte geben";
 $l[\'minus\'] = "Punkte abziehen";
 $l[\'send\'] = "Abschicken";
 
 $l[\'hauspunkte_no_usname\'] = "Der Username muss ausgefüllt sein!";
 $l[\'hauspunkte_no_reason\'] = "Es muss ein Grund angegeben werden!";
 $l[\'hauspunkte_no_points\'] = "Dieser Charakter hat keine Punkte, die abgezogen werden können!";
 $l[\'hauspunkte_no_student\'] = "Dieser Charakter kann keine Punkte erhalten oder verlieren!";
 
 $l[\'points_reason\'] ="Einteilung in das Haus";
 $l[\'pm_subject\'] ="Punkteverteilung";
 $l[\'hauspunkte_pn\'] = "Hallo {username},
 
 Dir wurden Punkte zugeteilt oder abgezogen, dies geschah mit folgenden Informationen:
 
 Von wem: {adminname}
 Grund: {reason}
 Punkte: {choice}{points}
 
 Mit freundlichen Grüßen
 Das Forensystem";';

	$phpname[3]='../inc/languages/english/hauspunkte.lang.php';
	$phpinhalt[3]='<?php
/**
 * English language pack for MyBB 1.8
 * Englisches Sprachpaket für MyBB 1.8
 * (c) 2005-2014 MyBBoard.de
 * 
 * Author/Autor: http://www.mybboard.de/
 * License/Lizenz: GNU Lesser General Public License, Version 3
 */
 
 $l[\'hauspunkte_name\'] = "Add/subtract points";
 
 $l[\'username\'] = "Student name";
 $l[\'reason\'] = "Reason for the points";
 $l[\'choice\'] = "Should points be given or deducted?";
 $l[\'points\'] = "How many points should be deducted / deducted?";
 $l[\'plus\'] = "Give points";
 $l[\'minus\'] = "Deduct points";
 $l[\'send\'] = "Send";
 
 $l[\'hauspunkte_no_usname\'] = "The username must be filled!";
 $l[\'hauspunkte_no_reason\'] = "There must be a reason given!";
 $l[\'hauspunkte_no_points\'] = "This character has no points that can be deducted!";
 $l[\'hauspunkte_no_student\'] = "This character can not get or lose points!";
 
 $l[\'points_reason\'] ="Division into the house";
 $l[\'pm_subject\'] ="Point distribution";
 $l[\'hauspunkte_pn\'] = "Hello {username},
 
 You have been awarded or deducted points, this happened with the following information:
 
 From whom: {adminname}
 Reason: {reason}
 Points: {choice}{points}
 
 Yours sincerely
 The forum system";';

	$i=0;
	$max=count($phpname);
	while($i<$max)
	{
		$filename=$phpname[$i];
		$inhalt=$phpinhalt[$i];
		
		$handle = fopen ($mybb->settings['bburl'].$filename, 'a+');
		fwrite ($handle, $inhalt);
		fclose ($handle);
		$i++;
	}
}

function hauspunkte_deactivate()
{
	global $db, $cache, $lang;
	
	$lang->load('hauspunkte');
	
	$db->delete_query('settings', "name LIKE 'points_per_%'");
	$db->delete_query('settinggroups', "name = '{$lang->points_lowername}'");
	rebuild_settings();
	
	$db->delete_query("templates", "title = 'hauspunkte'");
	
	unlink('../hauspunkte.php');
	unlink('../inc/languages/deutsch_sie/hauspunkte.lang.php');
	unlink('../inc/languages/deutsch_du/hauspunkte.lang.php');
	unlink('../inc/languages/english/hauspunkte.lang.php');
}

function hauspunkte_install()
{
	global $db, $cache, $lang;
	
	
	$plugins_cache = $cache->read("plugins");
	if (!isset($plugins_cache['active']['hp_listen']))
	{
		global $page, $lang;
		$lang->load('hauspunkte');
		$page->output_confirm_action('index.php?module=config-plugins&action=deactivate&uninstall=1&plugin=hello', $lang->HP_list_activate_message, $lang->HP_list_activate);
	}
	else if (!isset($plugins_cache['active']['inplaytracker']))
	{
		global $page, $lang;
		$lang->load('hauspunkte');
		$page->output_confirm_action('index.php?module=config-plugins&action=deactivate&uninstall=1&plugin=hello', $lang->inplaytracker_activate_message, $lang->inplaytracker_activate);
	}
	else hauspunkte_install_do();
}

function hauspunkte_install_do()
{
	global $db, $cache, $lang;
	
	
	$db->add_column("users","points","int(255)");
}

function hauspunkte_is_installed()
{
	global $db,$lang;
	
	$lang->load('hauspunkte');
	
	$existfield=$db->field_exists("points","users");
    
	
	return $existfield;
}

function hauspunkte_uninstall()
{
	global $db, $cache, $lang;
	
	
	$db->drop_column("users","points");
}

function punkte_einteilung()
{
	global $db, $uid, $lang;
	$lang->load('hauspunkte');
	
	$query = $db->simple_select("settings", 'value', "name='points_per_wob'");
	$pointinfo = $db->fetch_array($query);
	$points=$pointinfo['value'];
	
	$query = $db->simple_select("userfields", 'fid13', "ufid='{$uid}'");
	$fidinfo = $db->fetch_array($query);
	
	$query = $db->simple_select("users", 'points', "uid='{$uid}'");
	$userinformations = $db->fetch_array($query);
	
	$npoints=$points+$userinformations['points'];
	
	if($fidinfo['fid13'])
	{
		$update_user = array(
		"points" => $npoints
		);
		$db->update_query("users", $update_user, "uid='".$uid."'");
			
		$reason=$lang->points_reason;
		hauspunkte_pn(1,$uid,"+",$points,$reason);
	}
}

function punkte_post()
{
	global $mybb, $forum, $uid, $db, $lang;
	$lang->load('hauspunkte');
	
	
	$inplaykategorie = $mybb->settings['inplaytracker_forum'];
	if(preg_match("/,$inplaykategorie,/i", $forum['parentlist']))
	{
		$query = $db->simple_select("settings", 'value', "name='points_per_post'");
		$pointinfo = $db->fetch_array($query);
		$points=$pointinfo['value'];
		
		$query = $db->simple_select("userfields", 'fid13', "ufid='{$uid}'");
		$fidinfo = $db->fetch_array($query);
	
		$query = $db->simple_select("users", 'points', "uid='{$uid}'");
		$userinformations = $db->fetch_array($query);
		
		$npoints=$points+$userinformations['points'];
		
		if($fidinfo['fid13'])
		{
			$update_user = array(
			"points" => $npoints
			);
			$db->update_query("users", $update_user, "uid='".$uid."'");
		}
	}
}

function showpoints()
{
	global $db,$hauspunkte;
	
	$hauspunkte=array();
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);
	while($row=$db->fetch_array($result))
	{
		$hauser=explode('<br />',nl2br($row['type']));
		$i=0;
		foreach($hauser as $haus)
		{
			if($i>0)
			{
				$haus=trim($haus);
				$value;
				
				$query = $db->query("
				SELECT u.points FROM ".TABLE_PREFIX."users u
				LEFT JOIN ".TABLE_PREFIX."userfields f ON(u.uid=f.ufid)
				WHERE f.fid13='{$haus}'
				");
				
				$haus=strtolower($haus);
				$value=0;
				
				while($row=$db->fetch_array($query))
				{
					$value=$value+$row['points'];
				}
				
				$hauspunkte[$haus."_points"]=$value;
				$hauspunkte[$haus."_name"]=$haus;
			}
			else $i++;
		}
	}
}

function hauspunkte_pn($fromid,$toid,$choice,$points,$reason)
{
	global $mybb, $db, $lang, $session;
	$lang->load('hauspunkte');
	
	
	require_once MYBB_ROOT."inc/datahandlers/pm.php";
	$pmhandler = new PMDataHandler();
	
	$query = $db->simple_select("users", 'uid,username', "uid='{$toid}'");
	$userinfo = $db->fetch_array($query);
	
	$query = $db->simple_select("users", 'uid,username', "uid='{$fromid}'");
	$admininfo = $db->fetch_array($query);
	
	$message=$lang->hauspunkte_pn;
	$message=str_replace('{username}',$userinfo['username'],$message);
	$message=str_replace('{adminname}',$admininfo['username'],$message);
	$message=str_replace('{reason}',$reason,$message);
	$message=str_replace('{choice}',$choice,$message);
	$message=str_replace('{points}',$points,$message);
	
	$pm = array(
		"subject" => $lang->pm_subject,
		"message" => $message,
		"icon" => 1,
		"fromid" => $fromid,
		"do" => '',
		"pmid" => 0,
		"ipaddress" => $session->packedip,
		"toid" => $toid,
		"saveasdraft" => 0
	);
	$pm['options']['signature'] = 1;
	$pm['options']['disablesmilies'] = 0;
	$pm['options']['savecopy'] = 0;
	$pm['options']['readreceipt'] = 0;
	
	
	$pmhandler->set_data($pm);
	
	if(!$pmhandler->validate_pm())
	{
		$pm_errors = $pmhandler->get_friendly_errors();
		$send_errors = inline_error($pm_errors);
		echo $send_errors;
	}
	else
	{
		$pminfo = $pmhandler->insert_pm();
	}
}